package co.jp.mamol.myapp.service;

import co.jp.mamol.myapp.model.SizaiModel;
import co.jp.mamol.myapp.repository.BuyApprovalRepository;
import co.jp.mamol.myapp.repository.BuyRequestRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class BuyApprovalService {

    @Autowired
    BuyApprovalRepository buyApprovalRepository;

    //BL 2001
    public List<SizaiModel> getDeptRequestList(String startDate, String endDate, String request_dept_id){

        List<SizaiModel> sizaiList = new ArrayList<SizaiModel>();

		/*// 00:00:00
		LocalDateTime startDateTime = startDate.atStartOfDay();
		// 23:59:59
		LocalDateTime endDateTime = endDate.atTime(23, 59, 59); */

        //00:00:00
        String startDateTime = startDate + " 00:00:00";
        //23:59:59
        String endDateTime = endDate + " 23:59:59";

        sizaiList = buyApprovalRepository.getDeptRequestList(startDateTime, endDateTime, request_dept_id);

        return sizaiList;
    }

    // BL 2003
    public boolean approval(int id){

        return buyApprovalRepository.approval(id);
    }

    // BL 2004
    public boolean reject(int id){

        return buyApprovalRepository.reject(id);
    }

    // BL 2002
    public SizaiModel getRequest(int id){

        return buyApprovalRepository.getRequestById(id);
    }
}
