package co.jp.mamol.myapp.service;

import co.jp.mamol.myapp.model.UserModel;
import co.jp.mamol.myapp.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public class PasswordMigrationService {

    private final UserRepository userRepository;
    private PasswordEncoder passwordEncoder;


    public PasswordMigrationService(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    @Autowired
    public PasswordMigrationService(UserRepository userRepository, PasswordEncoder passwordEncoder) {

        this.userRepository = userRepository;
        this.passwordEncoder = passwordEncoder;
    }

    @Transactional
    public void migrateExistingPasswords() {

        System.out.println("PasswordMigrationService.migrateExistingPasswords");
        List<UserModel> usersToMigrate = userRepository.findAllUsersForPasswordMigration();
        int count = 0;

        if (usersToMigrate.isEmpty()) {
            System.out.println("No users to migrate");
            return;
        }

        for (UserModel user : usersToMigrate){
            String plainPassword = user.getPassword();

            if (plainPassword != null && !plainPassword.isEmpty()) {

                if (plainPassword.length() == 60 && plainPassword.matches("^\\$2[aby]\\$\\d{2}\\$.*")) {

                }
            }
        }
    }
}
